BUILD_DIR = linux/Release_Build

default: builddir linux/Release_Build/pboom

all: default

linux/Release_Build/algs.o: algs.cpp
	g++ -c -o $(BUILD_DIR)/algs.o -MD -I\usr\include -I\usr\include\g++-3  algs.cpp

linux/Release_Build/boom.o: boom.cpp
	g++ -c -o $(BUILD_DIR)/boom.o -MD -I\usr\include -I\usr\include\g++-3  boom.cpp

linux/Release_Build/buffers.o: buffers.cpp
	g++ -c -o $(BUILD_DIR)/buffers.o -MD -I\usr\include -I\usr\include\g++-3  buffers.cpp

linux/Release_Build/bufferstruct.o: bufferstruct.cpp
	g++ -c -o $(BUILD_DIR)/bufferstruct.o -MD -I\usr\include -I\usr\include\g++-3  bufferstruct.cpp

linux/Release_Build/cd.o: cd.cpp
	g++ -c -o $(BUILD_DIR)/cd.o -MD -I\usr\include -I\usr\include\g++-3  cd.cpp

linux/Release_Build/checks.o: checks.cpp
	g++ -c -o $(BUILD_DIR)/checks.o -MD -I\usr\include -I\usr\include\g++-3  checks.cpp

linux/Release_Build/conf.o: conf.cpp
	g++ -c -o $(BUILD_DIR)/conf.o -MD -I\usr\include -I\usr\include\g++-3  conf.cpp

linux/Release_Build/cover.o: cover.cpp
	g++ -c -o $(BUILD_DIR)/cover.o -MD -I\usr\include -I\usr\include\g++-3  cover.cpp

linux/Release_Build/decomp.o: decomp.cpp
	g++ -c -o $(BUILD_DIR)/decomp.o -MD -I\usr\include -I\usr\include\g++-3  decomp.cpp

linux/Release_Build/dft.o: dft.cpp
	g++ -c -o $(BUILD_DIR)/dft.o -MD -I\usr\include -I\usr\include\g++-3  dft.cpp

linux/Release_Build/fcmin.o: fcmin.cpp
	g++ -c -o $(BUILD_DIR)/fcmin.o -MD -I\usr\include -I\usr\include\g++-3  fcmin.cpp

linux/Release_Build/ie.o: ie.cpp
	g++ -c -o $(BUILD_DIR)/ie.o -MD -I\usr\include -I\usr\include\g++-3  ie.cpp

linux/Release_Build/implcheck.o: implcheck.cpp
	g++ -c -o $(BUILD_DIR)/implcheck.o -MD -I\usr\include -I\usr\include\g++-3  implcheck.cpp

linux/Release_Build/ir.o: ir.cpp
	g++ -c -o $(BUILD_DIR)/ir.o -MD -I\usr\include -I\usr\include\g++-3  ir.cpp

linux/Release_Build/kernel.o: kernel.cpp
	g++ -c -o $(BUILD_DIR)/kernel.o -MD -I\usr\include -I\usr\include\g++-3  kernel.cpp

linux/Release_Build/simulate.o: simulate.cpp
	g++ -c -o $(BUILD_DIR)/simulate.o -MD -I\usr\include -I\usr\include\g++-3  simulate.cpp

linux/Release_Build/tboolfnct.o: tboolfnct.cpp
	g++ -c -o $(BUILD_DIR)/tboolfnct.o -MD -I\usr\include -I\usr\include\g++-3  tboolfnct.cpp

linux/Release_Build/tpfnct.o: tpfnct.cpp
	g++ -c -o $(BUILD_DIR)/tpfnct.o -MD -I\usr\include -I\usr\include\g++-3  tpfnct.cpp

linux/Release_Build/pboom: linux/Release_Build/algs.o linux/Release_Build/boom.o linux/Release_Build/buffers.o \
         linux/Release_Build/bufferstruct.o linux/Release_Build/cd.o linux/Release_Build/checks.o \
         linux/Release_Build/conf.o linux/Release_Build/cover.o linux/Release_Build/decomp.o \
         linux/Release_Build/dft.o linux/Release_Build/fcmin.o linux/Release_Build/ie.o \
         linux/Release_Build/implcheck.o linux/Release_Build/ir.o linux/Release_Build/kernel.o \
         linux/Release_Build/simulate.o linux/Release_Build/tboolfnct.o linux/Release_Build/tpfnct.o \
        
	g++ -o $(BUILD_DIR)/pboom  linux/Release_Build/algs.o linux/Release_Build/boom.o linux/Release_Build/buffers.o linux/Release_Build/bufferstruct.o linux/Release_Build/cd.o linux/Release_Build/checks.o linux/Release_Build/conf.o linux/Release_Build/cover.o linux/Release_Build/decomp.o linux/Release_Build/dft.o linux/Release_Build/fcmin.o linux/Release_Build/ie.o linux/Release_Build/implcheck.o linux/Release_Build/ir.o linux/Release_Build/kernel.o linux/Release_Build/simulate.o linux/Release_Build/tboolfnct.o linux/Release_Build/tpfnct.o

builddir:
	-mkdir -p linux
	-mkdir -p linux/Release_Build

clean:
	-rm linux/Release_Build/algs.o
	-rm linux/Release_Build/algs.d
	-rm linux/Release_Build/boom.o
	-rm linux/Release_Build/boom.d
	-rm linux/Release_Build/buffers.o
	-rm linux/Release_Build/buffers.d
	-rm linux/Release_Build/bufferstruct.o
	-rm linux/Release_Build/bufferstruct.d
	-rm linux/Release_Build/cd.o
	-rm linux/Release_Build/cd.d
	-rm linux/Release_Build/checks.o
	-rm linux/Release_Build/checks.d
	-rm linux/Release_Build/conf.o
	-rm linux/Release_Build/conf.d
	-rm linux/Release_Build/cover.o
	-rm linux/Release_Build/cover.d
	-rm linux/Release_Build/decomp.o
	-rm linux/Release_Build/decomp.d
	-rm linux/Release_Build/dft.o
	-rm linux/Release_Build/dft.d
	-rm linux/Release_Build/fcmin.o
	-rm linux/Release_Build/fcmin.d
	-rm linux/Release_Build/ie.o
	-rm linux/Release_Build/ie.d
	-rm linux/Release_Build/implcheck.o
	-rm linux/Release_Build/implcheck.d
	-rm linux/Release_Build/ir.o
	-rm linux/Release_Build/ir.d
	-rm linux/Release_Build/kernel.o
	-rm linux/Release_Build/kernel.d
	-rm linux/Release_Build/simulate.o
	-rm linux/Release_Build/simulate.d
	-rm linux/Release_Build/tboolfnct.o
	-rm linux/Release_Build/tboolfnct.d
	-rm linux/Release_Build/tpfnct.o
	-rm linux/Release_Build/tpfnct.d
	-rm linux/Release_Build/pboom

