//---------------------------------------------------------------------------
#include "algs.h"
//---------------------------------------------------------------------------
void QSDivid( int i, int j, int * fld )
{
  int i0, j0, k;
  int x, w;

  if ( i < j )
  {
    i0 = i;
    j0 = j;
    k = ( ( j - i ) / 2 ) + i;
    x = fld[k];
    do
    {
      while ( fld[i] < x ) i++;
      while ( fld[j] > x ) j--;
      if ( i <= j )
      {
        w = fld[i];
        fld[i] = fld[j];
        fld[j] = w;
        i++;
        j--;
      }
    }
    while ( i <= j );
    QSDivid( i0, k, fld );
    QSDivid( k + 1, j0, fld );
  }
}
//---------------------------------------------------------------------------
void QuickSort( int * fld, int len ) /* Quicksorts a field of ints */
{
  QSDivid( 0, len - 1, fld );
}
//---------------------------------------------------------------------------
int QFind_alg( int * fld, int val, int i, int j )
{
  int k;

  if ( j < i ) return false;
  k = ( ( j - i ) / 2 ) + i;
  if ( fld[k] == val ) return true;
  else if ( fld[k] < val ) return QFind_alg( fld, val, k + 1, j );
  else
    return QFind_alg( fld, val, i, k - 1 );
}
//---------------------------------------------------------------------------
int QFind( int * fld, int len, int val ) /* Determines, whether value val is in sorted field fld of length len */
{
  return QFind_alg( fld, val, 0, len - 1 );
}
//---------------------------------------------------------------------------
