//---------------------------------------------------------------------------
#include <string.h>
//---------------------------------------------------------------------------
#include "tboolfnct.h"
#include "bufferstruct.h"
#include "tpfnct.h"
//---------------------------------------------------------------------------
TBoolFnct * CreateHistory( TBoolFnct * fn )
{
  TBoolFnct * fn1;
  fn1 = fn->CreateChildFnct();
  fn1->outvars = fn1->inpvars;
  return fn1;
}
//---------------------------------------------------------------------------
int IsInHistory( TBoolFnct * fn, TPfnct * ff ) //0=neni tam, 1=je tam
{
  TPfnct * ff1;

  ff1 = fn->fnct;
  while ( ff1 != 0 )
  {
    if ( strcmp( ff->iv, ff1->iv ) == 0 ) return 1;
    ff1 = ff1->next;
  }
  return 0;
}
//---------------------------------------------------------------------------
void AddToHistory( TBoolFnct * fn, TPfnct * ff )
{
  TPfnct * t;
  t = new TPfnct;
  t->valid = 1;
  t->cov = 0;
  t->covfield = 0;
  t->dim = ff->dim;
  t->dvar = ff->dvar;
  t->iv = new char[fn->inpvars + 1];
  memcpy( t->iv, ff->iv, fn->inpvars );
  t->iv[fn->inpvars] = 0;
  t->ov = new char[fn->inpvars + 1];
  t->ov[0] = 0;
  t->next = 0;
  if ( fn->last != 0 ) fn->last->next = t;
  fn->last = t;
  if ( fn->fnct == 0 ) fn->fnct = t;
  fn->terms++;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
TermTree::TreeNode * TermTree::AddTreeNode()
{
  TreeNode * tn;
  tn = new TreeNode;
  tn->on = 0;
  tn->off = 0;
  tn->dc = 0;
  this->nodes++;
  return tn;
}
//---------------------------------------------------------------------------
TermTree::TermTree( TBoolFnct * fn )
{
  this->nodes = 0;
  this->root = this->AddTreeNode();
  this->items = 0;
  this->inpvars = fn->inpvars;
}
//---------------------------------------------------------------------------
TermTree::TermTree( int iv )
{
  this->nodes = 0;
  this->root = this->AddTreeNode();
  this->items = 0;
  this->inpvars = iv;
}
//---------------------------------------------------------------------------
int TermTree::IsInTreeHistory( TPfnct * ff ) //0=neni tam, 1=je tam
{
  TreeNode * tn;
  int i;
  tn = this->root;
  for ( i = 0; i < this->inpvars; i++ )
  {
    if ( ff->iv[i] == '0' ) tn = tn->off;
    if ( ff->iv[i] == '1' ) tn = tn->on;
    if ( ff->iv[i] == '-' ) tn = tn->dc;
    if ( tn == 0 ) return 0;
  }
  return tn->value;
}
//---------------------------------------------------------------------------
TPfnct * TermTree::IsTermInTreeHistory2( char * t ) //0=neni tam, 1=je tam
{
  TreeNode * tn;
  int i;
  tn = this->root;
  for ( i = 0; i < this->inpvars; i++ )
  {
    if ( t[i] == '0' ) tn = tn->off;
    if ( t[i] == '1' ) tn = tn->on;
    if ( t[i] == '-' ) tn = tn->dc;
    if ( tn == 0 ) return 0;
  }
  return tn->ff;
}
//---------------------------------------------------------------------------
void TermTree::DestroyTreeNode( TreeNode * tn )
{
  if ( tn != 0 )
  {
    DestroyTreeNode( tn->on );
    DestroyTreeNode( tn->off );
    DestroyTreeNode( tn->dc );
    delete tn;
  }
}
//---------------------------------------------------------------------------
void TermTree::DeleteTermFromTreeHistory( char * t )
{
  TreeNode * tn, * tn1;
  int i;

  tn1 = 0;
  tn = this->root;
  for ( i = 0; i < this->inpvars; i++ )
  {
    if ( t[i] == '0' )
    {
      if ( tn->on == 0 && tn->dc == 0 )
      {
        if ( tn1 == 0 ) tn1 = tn;
      }
      else
        tn1 = 0;
      tn = tn->off;
    }
    else if ( t[i] == '1' )
    {
      if ( tn->off == 0 && tn->dc == 0 )
      {
        if ( tn1 == 0 ) tn1 = tn;
      }
      else
        tn1 = 0;
      tn = tn->on;
    }
    else if ( t[i] == '-' )
    {
      if ( tn->on == 0 && tn->off == 0 )
      {
        if ( tn1 == 0 ) tn1 = tn;
      }
      else
        tn1 = 0;
      tn = tn->dc;
    }
  }
  if ( tn1 == 0 ) tn1 = tn;
  tn = this->root;
  for ( i = 0; i < this->inpvars; i++ )
  {
    if ( t[i] == '0' )
    {
      if ( tn->off == tn1 )
      {
        DestroyTreeNode( tn->off );
        tn->off = 0;
        break;
      }
      tn = tn->off;
    }
    else if ( t[i] == '1' )
    {
      if ( tn->on == tn1 )
      {
        DestroyTreeNode( tn->on );
        tn->on = 0;
        break;
      }
      tn = tn->on;
    }
    else if ( t[i] == '-' )
    {
      if ( tn->dc == tn1 )
      {
        DestroyTreeNode( tn->dc );
        tn->dc = 0;
        break;
      }
      tn = tn->dc;
    }
  }
  this->items--;
}
//---------------------------------------------------------------------------
int TermTree::IsInTreeHistory( char * t ) //0=neni tam, 1=je tam
{
  TreeNode * tn;
  int i;

  tn = this->root;
  for ( i = 0; i < this->inpvars; i++ )
  {
    if ( t[i] == 0 ) tn = tn->off;
    if ( t[i] == 1 ) tn = tn->on;
    if ( tn == 0 ) return 0;
  }
  return tn->value;
}
//---------------------------------------------------------------------------
int TermTree::AddToTreeHistory( TPfnct * ff ) //0=nebyl tam, 1=byl tam, jinak val
{
  TreeNode * tn;
  int i, c;

  tn = this->root;
  c = 1;
  for ( i = 0; i < this->inpvars; i++ )
  {
    if ( ff->iv[i] == '0' )
    {
      if ( tn->off == 0 )
      {
        tn->off = this->AddTreeNode();
        c = 0;
      }
      tn = tn->off;
    }
    else if ( ff->iv[i] == '1' )
    {
      if ( tn->on == 0 )
      {
        tn->on = this->AddTreeNode();
        c = 0;
      }
      tn = tn->on;
    }
    else if ( ff->iv[i] == '-' )
    {
      if ( tn->dc == 0 )
      {
        tn->dc = this->AddTreeNode();
        c = 0;
      }
      tn = tn->dc;
    }
  }
  if ( c == 0 )
  {
    this->items++;
    tn->value = 1;
  }
  return c;
}
//---------------------------------------------------------------------------
int TermTree::AddToTreeHistory( char * t ) //0=nebyl tam, 1=byl tam, jinak val
{
  TreeNode * tn;
  int i, c;

  tn = this->root;
  c = 1;
  for ( i = 0; i < this->inpvars; i++ )
  {
    if ( t[i] == 0 )
    {
      if ( tn->off == 0 )
      {
        tn->off = this->AddTreeNode();
        c = 0;
      }
      tn = tn->off;
    }
    else if ( t[i] == 1 )
    {
      if ( tn->on == 0 )
      {
        tn->on = this->AddTreeNode();
        c = 0;
      }
      tn = tn->on;
    }
  }
  if ( c == 0 )
  {
    this->items++;
    tn->value = 1;
  }
  return c;
}
//---------------------------------------------------------------------------
int TermTree::AddToTreeHistory2( char * t ) //0=nebyl tam, 1=byl tam, jinak val
{
  TreeNode * tn;
  int i, c;

  tn = this->root;
  c = 1;
  for ( i = 0; i < this->inpvars; i++ )
  {
    if ( t[i] == '0' )
    {
      if ( tn->off == 0 )
      {
        tn->off = this->AddTreeNode();
        c = 0;
      }
      tn = tn->off;
    }
    else if ( t[i] == '1' )
    {
      if ( tn->on == 0 )
      {
        tn->on = this->AddTreeNode();
        c = 0;
      }
      tn = tn->on;
    }
    else if ( t[i] == '-' )
    {
      if ( tn->dc == 0 )
      {
        tn->dc = this->AddTreeNode();
        c = 0;
      }
      tn = tn->dc;
    }
  }
  if ( c == 0 )
  {
    this->items++;
    tn->value = 1;
  }
  return c;
}
//---------------------------------------------------------------------------
TPfnct * TermTree::AddTermToTreeHistory( TPfnct * ff ) //0 = not found
{
  TreeNode * tn;
  int i, c;

  tn = this->root;
  c = 1;
  for ( i = 0; i < this->inpvars; i++ )
  {
    if ( ff->iv[i] == '0' )
    {
      if ( tn->off == 0 )
      {
        tn->off = this->AddTreeNode();
        c = 0;
      }
      tn = tn->off;
    }
    else if ( ff->iv[i] == '1' )
    {
      if ( tn->on == 0 )
      {
        tn->on = this->AddTreeNode();
        c = 0;
      }
      tn = tn->on;
    }
    else if ( ff->iv[i] == '-' )
    {
      if ( tn->dc == 0 )
      {
        tn->dc = this->AddTreeNode();
        c = 0;
      }
      tn = tn->dc;
    }
  }
  if ( c == 0 )
  {
    this->items++;
    tn->ff = ff;
    return 0;
  }
  return tn->ff;
}
//---------------------------------------------------------------------------
TermTree::TreeNode * TermTree::ValAddToTreeHistory( TPfnct * ff, int val ) // 0 = nebyl tam, *node = byl tam
{
  TreeNode * tn;
  int i, c;

  tn = this->root;
  c = 1;
  for ( i = 0; i < this->inpvars; i++ )
  {
    if ( ff->iv[i] == '0' )
    {
      if ( tn->off == 0 )
      {
        tn->off = this->AddTreeNode();
        c = 0;
      }
      tn = tn->off;
    }
    else if ( ff->iv[i] == '1' )
    {
      if ( tn->on == 0 )
      {
        tn->on = this->AddTreeNode();
        c = 0;
      }
      tn = tn->on;
    }
    else if ( ff->iv[i] == '-' )
    {
      if ( tn->dc == 0 )
      {
        tn->dc = this->AddTreeNode();
        c = 0;
      }
      tn = tn->dc;
    }
  }
  if ( c == 0 )
  {
    this->items++;
    tn->value = val;
    return 0;
  }
  return tn;
}
//---------------------------------------------------------------------------
TermTree::TreeNode * TermTree::ValAddToTreeHistory( char * t, int val ) // 0 = nebyl tam, *node = byl tam
{
  TreeNode * tn;
  int i, c;

  tn = this->root;
  c = 1;
  for ( i = 0; i < this->inpvars; i++ )
  {
    if ( t[i] == '0' )
    {
      if ( tn->off == 0 )
      {
        tn->off = this->AddTreeNode();
        c = 0;
      }
      tn = tn->off;
    }
    else if ( t[i] == '1' )
    {
      if ( tn->on == 0 )
      {
        tn->on = this->AddTreeNode();
        c = 0;
      }
      tn = tn->on;
    }
    else if ( t[i] == '-' )
    {
      if ( tn->dc == 0 )
      {
        tn->dc = this->AddTreeNode();
        c = 0;
      }
      tn = tn->dc;
    }
  }
  if ( c == 0 )
  {
    this->items++;
    tn->value = val;
    return 0;
  }
  return tn;
}
//---------------------------------------------------------------------------
