//---------------------------------------------------------------------------
#ifndef coverH
  #define coverH
//---------------------------------------------------------------------------
class TPfnct;
//---------------------------------------------------------------------------
struct TCovs
{
  TPfnct * fn; // covered ON-set term pointer
  int index;
  int var; // covered output variable
  TCovs * next;
};
//---------------------------------------------------------------------------
struct CovLink
{
  TPfnct * term;
  int index;
  CovLink * prev;
  CovLink * next;
  double contrib;
  unsigned long * vct;
  int count;
};
//---------------------------------------------------------------------------
struct CovSol
{
  int solcost;
  CovLink * sol;
};
//---------------------------------------------------------------------------
class TBoolFnct;
//---------------------------------------------------------------------------
struct CovMatrix
{
  TBoolFnct * fn;
  int cols;
  int origrows;
  int rows;
  CovLink * col;
  CovLink * row;
  char * * matrix;
  int covs;
  CovLink * sol;
  int solcost;
  int dact;
  int cleancheck;
  int block;
  int sparsing;
};
//---------------------------------------------------------------------------
TBoolFnct * Cover( TBoolFnct * fn );
TBoolFnct * SOCover( TBoolFnct * fn );
TBoolFnct * BlockCover( TBoolFnct * fn );
void FindCover( TBoolFnct * fn );
void SparseOutput( TBoolFnct * fn );
//---------------------------------------------------------------------------
#endif
