//---------------------------------------------------------------------------
#include <stdlib.h> // srand
#include <limits.h> // INT_MAX
#include <string.h> // memcpy
#include <time.h>   // time_t
#include <sys/timeb.h> // timeb
//---------------------------------------------------------------------------
#include "decomp.h"
#include "kernel.h"
#include "cover.h"
//---------------------------------------------------------------------------
CovMatrix * bcm, * tbcm;
//---------------------------------------------------------------------------
#if (mintrck > 0)
double cd_time;
double exp_time;
double red_time;
double dom_time;
double cov_time;
double sprs_time;
struct timeb tr_t, tr_t1;
#endif
//---------------------------------------------------------------------------
#if 0
double GetCPUTime()
{
  HANDLE h;
  FILETIME t1, t2, t3, t4;
  int i;
  LARGE_INTEGER t;
  double dt;
  h = GetCurrentProcess();
  GetProcessTimes( h, & t1, & t2, & t3, & t4 );
  t.LowPart = t3.dwLowDateTime + t4.dwLowDateTime;
  t.HighPart = t3.dwHighDateTime + t4.dwHighDateTime;
  dt = ( double )t.QuadPart / 10000000;
  return dt;
}
#endif
//---------------------------------------------------------------------------
void InitOpts()
{
  mo->STOP_time = 0;
  mo->STOP_iterations = 1;
  mo->STOP_optimization = 0;
  mo->STOP_improvement = 0;
  mo->STOP_maxtime = 1;
  mo->STOP_maxiterations = 1;
  mo->STOP_optimizationval = 0;
  mo->STOP_improvementint = 1;
  mo->OPT_crit = 1;
  mo->CD_no = 0;
  mo->CD_mutations = 0;
  mo->CD_weights = 0;
  mo->IE_type = 3;
  mo->IR_no = 0;
  mo->IR_mutations = 0;
  mo->COV_type = 1;
  mo->COV_end = 0;
  mo->COV_somin = 0;
  mo->COV_substDC = 0;
  mo->IC_type = 0;
  mo->IC_memory = 0;
  mo->OR_no = 0;
  mo->DOM_type = 2;
  //    mo->ess = 0;
  mo->DECOMP_enable = 0;
  mo->DECOMP_CDenable = 0;
  mo->DECOMP_COVenable = 0;
  mo->DFT_enable = 0;
  mo->DFT_CDenable = 0;
  mo->DFT_COVenable = 0;
  strcpy( go->NOT_multiply, "" );
  strcpy( go->NOT_add, "+" );
  strcpy( go->NOT_neg, "'" );
  go->NOT_postneg = 1;
  go->NOT_savevarnames = 1;
  go->timer = 0;
  mo->dopts = new DecompositionOptions;
  mo->dopts->blocks = 1;
  mo->dopts->inps = new int[1];
  mo->dopts->inps[0] = INT_MAX;
  mo->dopts->outs = new int[1];
  mo->dopts->outs[0] = INT_MAX;
  mo->DECOMP_CD_force = 1;
  mo->DECOMP_COV_force = 1;
  mo->DECOMP_CD_loadforce = 0;
  mo->DECOMP_COV_loadforce = 0;
  mo->DFT_CD_force = 1;
  mo->DFT_COV_force = 1;
  mo->FC_DF_dir = 1;
  mo->FC_DF = 10;
  mo->CD_FC = 50;
}
//---------------------------------------------------------------------------
