//---------------------------------------------------------------------------
#include <string.h>
//---------------------------------------------------------------------------
#include "cover.h"
#include "tpfnct.h"
#include "tboolfnct.h"
//---------------------------------------------------------------------------
TPfnct::TPfnct()
{
  this->valid = 1;
  this->cov = 0;
  this->covfield = 0;
  this->dim = 0;
  this->prime = 0;
  this->origin = 0;
  this->iv = 0;
  this->ov = 0;
  this->next = 0;
}
//---------------------------------------------------------------------------
TPfnct& TPfnct::operator=(TPfnct &_pt)
{
  this->valid = _pt.valid;
  this->dim = _pt.dim;
  this->prime = _pt.prime;
  this->origin = _pt.origin;
  this->covlen = _pt.covlen;
  this->next = 0;
  if (_pt.covfield != 0)
  {
    this->covfield = new int(*_pt.covfield);
  }
  this->iv = new char[ strlen( _pt.iv ) + 1 ];
  strcpy(this->iv, _pt.iv);
  if (_pt.ov != 0)
  {
    this->ov = new char[ strlen( _pt.ov ) + 1 ];
    strcpy(this->ov, _pt.ov);
  }
  if (_pt.cov != 0)
  {
    this->cov = 0;
    TCovs *prev = 0;
    while (_pt.cov != 0)
    {
      TCovs *temp = new TCovs;
      temp->index = _pt.cov->index;
      temp->var = _pt.cov->var;
      //temp->fn = new TPfnct();
      //temp->fn->operator=(*_pt.cov->fn);
      temp->fn = _pt.cov->fn;
      if ( prev != 0 ) prev->next = temp;
      prev = temp;
      if ( this->cov == 0 ) this->cov = temp;
      _pt.cov = _pt.cov->next;
    }
    prev->next = 0;
  }
  return *this;
}
//---------------------------------------------------------------------------
TPfnct::TPfnct(TBoolFnct *_parent, char *_iv, char *_ov, int _tdim)
{
  this->valid = 1;
  this->cov = 0;
  this->covfield = 0;
  this->prime = 0;
  this->origin = 0;
  this->dim = _tdim;
  this->iv = new( char[_parent->inpvars + 1] );
  memcpy( iv, _iv, _parent->inpvars );
  this->iv[_parent->inpvars] = 0;
  if ( _ov != 0 )
  {
    this->ov = new( char[_parent->outvars + 1] );
    memcpy( ov, _ov, _parent->outvars );
    this->ov[_parent->outvars] = 0;
  }
  else
    this->ov = 0;
}
//---------------------------------------------------------------------------
TPfnct::~TPfnct()
{
}
//---------------------------------------------------------------------------
void TPfnct::DeleteCovs()
{
  TCovs * c, * c1;

  c = this->cov;
  while ( c != 0 )
  {
    c1 = c->next;
    delete c;
    c = c1;
  }
  this->cov = 0;
  delete[] this->covfield;
  this->covfield = 0;
}
//---------------------------------------------------------------------------
int TPfnct::CountPrimes()
{
  int i;

  i = 0;
  TPfnct *ff = this;
  while ( ff != 0 )
  {
    if ( ff->prime == 1 ) i++;
    ff = ff->next;
  }
  return i;
}
//---------------------------------------------------------------------------
int TPfnct::CountFCs()
{
  int i;

  i = 0;
  TPfnct *ff = this;
  while ( ff != 0 )
  {
    if ( ff->origin & 2 ) i++;
    ff = ff->next;
  }
  return i;
}
//---------------------------------------------------------------------------
int TPfnct::CountCommons()
{
  int i;

  i = 0;
  TPfnct *ff = this;
  while ( ff != 0 )
  {
    if ( ff->origin == 3 ) i++;
    ff = ff->next;
  }
  return i;
}
//---------------------------------------------------------------------------
int TPfnct::CountUnknowns()
{
  int i;

  i = 0;
  TPfnct *ff = this;
  while ( ff != 0 )
  {
    if ( ff->origin == 0 ) i++;
    ff = ff->next;
  }
  return i;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
TCovs * DuplCov( TCovs * c )
{
  TCovs * c1, * c2;

  c1 = 0;
  while ( c != 0 )
  {
    c2 = new TCovs;
    c2->fn = c->fn;
    c2->index = c->index;
    c2->var = c->var;
    c2->next = c1;
    c1 = c2;
    c = c->next;
  }
  return c1;
}
//---------------------------------------------------------------------------
int CountHamming( char * c1, char * c2, int len )
{
  int i, h;

  h = 0;
  for ( i = 0; i < len; i++ )
    if ( c1[i] != c2[i] && c1[i] != '-' && c2[i] != '-' ) h++;
  return h;
}
//---------------------------------------------------------------------------
char * JoinCubes( char * c1, char * c2, int len )
{
  int i;

  for ( i = 0; i < len; i++ )
    if ( c1[i] != c2[i] ) c1[i] = '-';
  return c1;
}
//---------------------------------------------------------------------------
int Contains( char * c1, char * c2, int len ) // returns true if c1 contains c2
{
  int i;
  for ( i = 0; i < len; i++ )
    if ( c1[i] != '-' && c2[i] != c1[i] ) break;
  return ( i == len );
}
//---------------------------------------------------------------------------
int Intersects( char * c1, char * c2, int len ) // returns true if c1 intersects c2
{
  int i;
  for ( i = 0; i < len; i++ )
    if ( c1[i] != '-' && c2[i] != '-' && c1[i] != c2[i] ) break;
  return ( i == len );
}
//---------------------------------------------------------------------------
